import Document from '../src/api/Document';

window.Drupal = {
  theme: {},
};
require('../src/theme/theme.index');

const searchApiLunrResult = window.Drupal.theme.searchApiLunrResult;

test('rendering a teaser with no info', () => {
  expect(searchApiLunrResult(new Document('foo', {}))).toBe('{"id":"foo","rawDocument":{}}');
});

test('rendering a teaser with a url and title', () => {
  expect(searchApiLunrResult(new Document('foo', {
    url: '/foo',
    title: 'Foo'
  }))).toMatchSnapshot()
});

test('rendering a teaser with a url, title and rendered item', () => {
  expect(searchApiLunrResult(new Document('foo', {
    url: '/foo',
    title: 'Foo',
    rendered_item: 'Sample content rendered...',
  }))).toMatchSnapshot()
});
