/**
 * Represents a document from the search index.
 *
 * @todo potentially look at adding some kind of SAPI configuration for which
 *   indexed fields should represent which fields in the schema. Ie, don't
 *   assume the summary comes from the 'rendered_entity' and the label from
 *   'title' etc.
 */
class Document {

  constructor(id, rawDocument) {
    this.id = id;
    this.rawDocument = rawDocument;
  }

  getId() {
    return this.id;
  }

  getUrl() {
    return this.rawDocument.url;
  }

  getLabel() {
    return this.rawDocument.title;
  }

  getSummary(searchTerm) {
    // @todo, make this more sophisticated.
    return this.rawDocument.rendered_item ? this.rawDocument.rendered_item.substr(0, 100) : null;
  }

}

export default Document;
